from . import ziPython
import re 

def autoDetect(exclude = [], host = 'localhost', port = 8005) :
    """Returns a string with the first device that is not
    in the exclude list. Will throw a RuntimeError if no
    device was found."""
    daq = ziPython.ziDAQServer(host, 8005);
    nodes = daq.listNodes('/', 0);
    devices = filter(lambda node: re.match("dev*", node, re.IGNORECASE), nodes);
    exclude = list(x.lower() for x in list(exclude));
    devices = filter(lambda node: node.lower() not in exclude, devices);
    if len(devices) == 0 :               
        raise RuntimeError("No DUT found. Make sure that the USB cable is connected to the host and the device is turned on.");
    # Found at least one device -> selection valid.
    # Select the first one
    device = devices[0].lower();
    print("AutoDetect selected the device %s for the measurement." % device);
    return device;

def devices(host = 'localhost', port = 8005) :
    """Returns a list of devices."""
    daq = ziPython.ziDAQServer(host, 8005);
    nodes = daq.listNodes('/', 0);
    devices = filter(lambda node: re.match("dev*", node, re.IGNORECASE), nodes);
    devices = list(x.lower() for x in list(devices));
    return devices;
